#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <time.h>
#include "terrain.h"

#define WIDTH	1000.0
//#define PIXELS	128
//#define PIXELS	512
#define PIXELS	256

#define URD	((float)rand() / (float)RAND_MAX)

int main(int argc, char **argv)
{
	terrain_t *map, *gaussian;
	unsigned char *data;
	int w, h;
	int i, j;
	float min, max;
	float ax, ay, rx, ry;
	FILE *rnd, *pgm;
	unsigned long l;
	char buffer[80];
fprintf(stderr, "whale\n");
	// seed the random number generator from /dev/urandom
	rnd = fopen("/dev/urandom", "rb");
	if (!rnd)
	{
		perror("islands: fopen(/dev/urandom)");
		srand(time(NULL));
	}
	else
	{
		fread(&l, sizeof(unsigned long), 1, rnd);
		srand(l);
		fclose(rnd);
	}


	// create 100 unit wide map of 256*256 pixels
	map = trn_new(PIXELS, PIXELS, 1/(WIDTH / PIXELS));
	gaussian = trn_new(PIXELS, PIXELS, 1/(WIDTH / PIXELS));

#ifndef TEST
	
	trn_addgaussian(gaussian, 0, 0, 40, 1); // PARAMETER
	trn_addcone(gaussian, 0, 0, WIDTH / 4, 0.01); // PARAMETER

	trn_minmax(gaussian, &min, &max);
	fprintf(stderr, "gaussian: %f, %f\n", min, max);

	trn_ridges(map, gaussian, 20, 15, 50, 20); // PARAMETER

	trn_minmax(map, &min, &max);

//	trn_tilt(map, 0, 0, URD, URD, 10 / WIDTH); // PARAMETER

	trn_addroughness(map, 1., 100. / WIDTH, 0.5); // PARAMETER
/*
	trn_gaussiannoise(map, 100, 100. / WIDTH);
	trn_minmax(map, &min, &max);
	
	printf("foo %e %e\n", min, max);
*/	
	trn_minmax(map, &min, &max);

	trn_raise(map, 0.01 * (min - max)); // PARAMETER
	trn_cutoff(map);

	pgm = fopen(argv[1], "wb");
	if (!pgm)
	{
		fprintf(stderr, "islands: fopen(%s): %s\n", argv[1], strerror());
		return 1;
	}
	
	trn_writepgm(map, pgm);
	fclose(pgm);

	pgm = fopen(argv[2], "wb");
	if (!pgm)
	{
		fprintf(stderr, "islands: fopen(%s): %s\n", argv[1], strerror());
		return 1;
	}
	
	trn_writecarray(map, pgm, "map");
	fclose(pgm);

	trn_free(map);
	trn_free(gaussian);
#else

	// silly test thingy
	for (i = 4; i < 8; i++)
	{
		sprintf(buffer, "test-%d.pgm", 1 << i);
		pgm = fopen(buffer, "wb");
		
		map = trn_new(1 << i, 1 << i, (float)(1 << i) / WIDTH);
		for (j = 1; j < 5; j++)
		{

//			trn_gaussiannoise(map, pow(2, j), 1);//20 / WIDTH);
			trn_gaussiannoise(map, 1, 1);
			trn_minmax(map, &min, &max);

			printf("%3i / %3d: % 10.2f % 10.2f % 10.2f\n", 1 << i, 1 << j, min, max, fabs(max - min) / pow(2, j));
			if (j == 1)
				trn_writepgm(map, pgm);
			
		}
		fclose(pgm);
	}
#endif	// TEST
}
